/******************************************************************************
 * caching.h
 *
 * Author:
 * Stelios Sidiroglou-Douskos <stelios@cs.columbia.edu>
 * Department of Computer Science - Columbia University
 *
 * Copyright (c) 2003 by Columbia University, all rights reserved.
 * ***************************************************************************/


#ifndef _CHACHING_H_
#define _CHACHING_H_

#include "main.h"

#ifndef ARM
	#include <curl/curl.h>          /* URL lib */
	#include <curl/types.h>
	#include <curl/easy.h>
#endif

int 
is_file_in_cache(struct parsed_request *req, 
				struct data_structures *data,
				int fd);

int 
get_from_cache(gpointer value, int fd);

void
put_in_cache (struct data_structures *data, char *path, char *url);

unsigned int get_number_in_cache(struct data_structures *data);

int
save_to_file(struct parsed_request *req, struct MemoryStruct *chunk,
             struct data_structures *data);

char * cache_strip_path(char *orig_url);

#endif /* _CHACHING_H_ */
