/*
 * generate_search.c
 */

#include <pthread.h>            /* Threading lib */
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <ctype.h>
#include <sys/stat.h>           /*mkdir */
#include "global.h"
#include "md5.h"

#include <sys/socket.h>         /* Network */
#include <string.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <sys/time.h>

#include <errno.h>


#include "proxyServer.h"
#include "generate_search.h"
#include "query_report_buffer.h"

#include "main.h"
#ifndef ARM
	#include <curl/curl.h>          /* URL lib */
	#include <curl/types.h>
	#include <curl/easy.h>
#endif

#define GEN_BUF_SIZE 20000
static void show_queries(char* outbuf, struct data_structures *data);

/*
 * generate_search()
 * This method responsible for creating an HTML document from the querry
 * report. 
 */
void generate_search(int fd, struct data_structures *data)
{
	char *outbuf;
	int bytes_sent;
	
	outbuf = malloc(GEN_BUF_SIZE);
	if (!outbuf) {
		fprintf(stderr, "Error:generate_search:: Couldn't allocate memory\n\n");
		return;
	}

	sprintf(outbuf,"<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0 Transitional//EN\"> \n");
	strcat(outbuf,"<HTML NAME=\"MAIN\">  \n");
	strcat(outbuf,"<HEAD>  \n");

	/*
	strcat(outbuf,"<META HTTP-EQUIV=\"refresh\" CONTENT=\"" +
					myquery.updatefreq + ";URL = http://7ds_control/Update\">\n");
	*/
	strcat(outbuf,"<META HTTP-EQUIV=\"refresh\" CONTENT=\"100\";URL = http://7ds_control/Update\">\n");

	strcat(outbuf,"  <TITLE>Wireless Data Sharing Network</TITLE>  \n");
	strcat(outbuf,"</HEAD> \n");
	strcat(outbuf,"<CENTER> \n");
	strcat(outbuf,"<img src=\"sevends.jpg\" name=\"image\" width=\"200\" height=\"200\">");
	//strcat(outbuf,"<H1>Wireless Data Sharing Network</H1> \n");
	strcat(outbuf,"</CENTER><BR> \n");
	strcat(outbuf,"<BODY bgcolor=\"white\" text=\"black\" marginwidth=\"0\" marginheight=\"0\" leftmargin=\"0\" topmargin=\"0\"> \n");
	strcat(outbuf,"<FORM ACTION=\"http://7ds_control/QuerySearch\">\n");
	strcat(outbuf,"<Center> \n");

	strcat(outbuf,"<FONT face=\"arial black\" size=4 color=\"blue\"><I> \n");
	strcat(outbuf,"Enter Keywords or URL: \n");
	strcat(outbuf,"</I></FONT> \n");
	strcat(outbuf,"<INPUT TYPE=\"TEXT\" NAME=\"query\" SIZE=\"40\"><BR><BR> \n");
	strcat(outbuf,"   <INPUT TYPE=\"SUBMIT\" VALUE=\"Search\"> \n");
	strcat(outbuf," </CENTER></FORM> \n");
      
	strcat(outbuf,"<CENTER> \n");
	strcat(outbuf,"<TABLE><TR>\n");
	strcat(outbuf,"<TD><FORM>\n");
     
	strcat(outbuf,"<INPUT TYPE=\"button\" VALUE=\"Update\" onclick=\"parent.location='http://7ds_control/Update'\"></FORM></TD> \n");

	strcat(outbuf,"<td><form><input type=\"button\" value = \"CacheViewer\" onClick=\"javascript:window.open('CACHE','CacheViewer','toolbar=0,location=0,directories=0,status=0,menubar=0,scrollbars=1,resizable=1,width=900,height=600')\"> </form></td> \n");
      
	strcat(outbuf,"<td> <form><input type=\"button\" value = \"Configuration\" onClick=\"javascript:window.open('CONFIG','Configuration','toolbar=0,location=0,directories=0,status=0,menubar=0,scrollbars=0,resizable=0,width=480,height=380')\"> </form></td> \n");
	strcat(outbuf,"</tr></table>\n");
	strcat(outbuf,"</CENTER> \n");
	strcat(outbuf,"<HR align=\"center\" size=\"3\" width=\"100%\"> \n");
      
	// Generate the list of queries in the QueryReportBuffer that are viewable
	strcat(outbuf,"<H2><I> \n");
	strcat(outbuf,"Query Results: </I></H2> \n");

	show_queries(outbuf, data);
			
	strcat(outbuf, "</BODY></HTML> \n");
	
	/* Write back to socket */
  	bytes_sent = send(fd, outbuf, strlen(outbuf), 0);
	
	if (bytes_sent == -1) {
        fprintf(stderr, "Error:generate_search: Error sending to socket%d\n", fd);
    }
	
	/* Don't forget to free buffer */
	free(outbuf);
	
}

/*
 * show_queries()
 * This method takes the query report buffer and prints the querries on the
 * 7ds_control web page
 */
static void show_queries(char* outbuf, struct data_structures *data)
{

	
	strcat(outbuf,"<TABLE position = top>\n");
	
	
	qrb_show_queries(outbuf);

	
	strcat(outbuf,"</TABLE>\n");
}
