/******************************************************************************
 *
 * glimpse_manager.c
 *
 * 
 * ***************************************************************************/
#include <pthread.h>            /* Threading lib */
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <ctype.h>

#define INDEX "glimpseindex -H index cache"
#define UPDATE_INDEX "glimpseindex -f -H index cache"
#define DEBUG(x) printf(x)

int glimpse_index_period = 10; /* seconds */

int get_glimpse_index_period() 
{	
	return glimpse_index_period;
}

void set_glimpse_index_period(int new_time)
{
	if (new_time > 0)
		glimpse_index_period = new_time;
}

void update_index()
{
	/*Update index then sleep*/
	DEBUG("glimpse_manager: Updating index\n");
	
	for (;;) {
		system(UPDATE_INDEX);
		sleep(glimpse_index_period);
	}
	
	
}

void glimpse_manager_init(char *filename)
{
	pthread_t glimpse_thread;

	/* 
	 * First create index if it's not there then loop for given time updating the 
	 * index
	 */
	
	system(INDEX);
	
	/*Launch update index thread */
	if ((pthread_create(&glimpse_thread,
                            NULL,
                            (void *(*)(void *)) update_index,
                            NULL)) != 0) {
            printf("Error -> glimpse_manager_init: Error creating thread\n");
	}

	
}


