/******************************************************************************
 * query_report_buffer.h
 *
 * Author:
 * Stelios Sidiroglou-Douskos <stelios@cs.columbia.edu>
 * Department of Computer Science - Columbia University
 *
 * Copyright (c) 2003 by Columbia University, all rights reserved.
 * ***************************************************************************/

#ifndef _QUERY_REPORT_BUFFER_H_
#define _QUERY_REPORT_BUFFER_H_

#include <glib.h>

#define ONE_STAR 	"<img src=\"star.ico\" name=\"image\">"
#define TWO_STAR	"<img src=\"star.ico\" name=\"image\"><img src=\"star.ico\" name=\"image\">"
#define THREE_STAR	"<img src=\"star.ico\" name=\"image\"><img src=\"star.ico\" name=\"image\"><img src=\"star.ico\" name=\"image\">"
#define FOUR_STAR	"<img src=\"star.ico\" name=\"image\"><img src=\"star.ico\" name=\"image\"><img src=\"star.ico\" name=\"image\"><img src=\"star.ico\" name=\"image\">"
#define FIVE_STAR	"<img src=\"star.ico\" name=\"image\"><img src=\"star.ico\" name=\"image\"><img src=\"star.ico\" name=\"image\"><img src=\"star.ico\" name=\"image\"><img src=\"star.ico\" name=\"image\">"

void query_report_buffer_init(void);
void query_init(query_t *query);
void qrb_append_report(report_t *report);
void qrb_append_queries(query_t *query);
void qrb_walk_queries(void);

GList* qrb_get_buffer(void);
GList* qrb_get_reports(void);

query_t * qrb_create_query(); 
int qrb_is_query_in_buffer(char *query);
void qrb_show_queries(char *outbuf);

report_t *qrb_create_report();
void qrb_walk_reports(query_t *query);
void qrb_add_report_to_query(query_t *query, report_t *report);

int qrb_is_query_expanded(query_t *query); 
void qrb_delete_query(char *descriptor);
void qrb_query_set_sort(char *descriptor, int sort_type);

int get_qrb_update_freq(void);
unsigned int get_qrb_broadcast_freq(void);
int get_qrb_num_of_broadcasts(void);
int get_qrb_buffer_freq(void);
int get_qrb_cleancache_period(void);
int get_qrb_expires(void);
int get_qrb_association_freq(void);
int get_qrb_query_time_out(void);
int get_qrb_energy(void);

#endif 
