/******************************************************************************
 *
 * Unicast receiver waits for unicast requests and processes them...
 *
 *
 *
 * ***************************************************************************/
#include <pthread.h>            /* Threading lib */
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <ctype.h>
#include <sys/stat.h>           /*mkdir */

#include <sys/socket.h>         /* Network */
#include <string.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <sys/time.h>
#include <errno.h>
#include <arpa/inet.h>

#include "xmlparser.h"			/*xml parser*/
#include "main.h"
#include "referer_hash.h"
#include "parser.h"

#ifndef ARM
	#include <curl/curl.h>          /* URL lib */
	#include <curl/types.h>
	#include <curl/easy.h>
#endif
#define MAX_LEN 65000
//#define RCV_REPORT_PORT	9000

/******Declarations **********************************************************/
static void handle_request(void *data);
extern int unicast_port_cfg;

/*
 * handle_request()
 * Here I need to able to parse the xml files...
 */
static void handle_request(void *data)
{
	char *mesg;
	
	unicast_t *unicast = (unicast_t	*) data;
	mesg = (char *) unicast->mesg;
	

	printf("handle_request:: got %s\n", mesg);
	printf("handle_request:: from %s\n", 
				inet_ntoa(unicast->client.sin_addr));
	
	if (parse_unicast_xml(mesg) == 0) {
		/*do stuff if you have correct xml */
	} else {
		fprintf(stderr, "handle_request:: Couldn't parse xml report\n");
	}	
}


/*
 * unicast_receiver_init()
 * This method is used to initialize the unicast receiver thread.
 * Here is where reports are reports to 7ds queries are received.
 */
int unicast_receiver_init()
{
	pthread_t request_thread;
    int listenfd;
    socklen_t clilen;
    struct sockaddr_in client_addr, server_addr;
    char mesg[MAX_LEN];
    int n;
	unicast_t unicast_data;

    /* create server socket */
    if ((listenfd = socket(AF_INET, SOCK_DGRAM, 0)) < 0) {
        printf("Error opening socket\n");
        return -1;
    }

    /* clear out struct */
    bzero(&server_addr, sizeof(server_addr));

    /* populate server address */
    server_addr.sin_family = AF_INET;
    server_addr.sin_addr.s_addr = htonl(INADDR_ANY);
    server_addr.sin_port = htons(unicast_port_cfg);

    if (bind
        (listenfd, (struct sockaddr *) &server_addr,
         sizeof(server_addr)) < 0) {
        printf("Error binding socket\n");
        return -1;
    }

    for (;;) {
		bzero(mesg, sizeof(mesg));
		clilen = sizeof(client_addr);
        //connfd = accept(listenfd, (struct sockaddr *)&client_addr, &clilen);
        n = recvfrom(listenfd,
                     mesg,
                     MAX_LEN,
                     0, (struct sockaddr *) &client_addr, &clilen);

        if (n < 0) {
            printf("errno = %d\n", errno);
            printf("unicast_receiver recvfrom error\n");
            break;
        }

		printf("Received Unicast report from %s:%d: %s\n",
                   inet_ntoa(client_addr.sin_addr), ntohs(client_addr.sin_port), mesg);

		unicast_data.mesg = mesg;
		unicast_data.client = client_addr;

        if ((pthread_create(&request_thread,
                            NULL,
                            (void *(*)(void *)) handle_request,
                            (void *) &unicast_data)) != 0) {
            printf("Error -> ProxyServer: Error creating thread\n");
        }
        /* Syncing */
        pthread_join(request_thread, NULL);
    }
	return 0;
}



