/*
 * xmlparser.h
 */

#ifndef _XMLPARSER_H
#define _XMLPARSER_H
#include <libxml/parser.h>
#include <libxml/xmlmemory.h>
#include "main.h"

#define XML_ROOT "SEVENDS_QUERY"

/* just for testing */
int test_parse_doc(char *filename, struct data_structures *data);
int parse_xml(char *mesg);
int create_query_xml(char *keyword, char *xml);
int parse_multicast_xml(char *mesg, char* request);
int parse_unicast_xml(char *mesg);

int create_xml_query_name(xmlNodePtr root, xmlNodePtr query_cur, char *keyword);
xmlNodePtr create_xml_query(xmlNodePtr root, xmlNodePtr query_cur, char *keyword);
int create_xml_local_url(xmlNodePtr root, xmlNodePtr query_cur, char *local_url);
int create_xml_report(xmlNodePtr root, xmlNodePtr query_cur, char *result);
int create_xml_root_doc(xmlDocPtr doc, xmlNodePtr root);
int create_xml_original_url(xmlNodePtr root, xmlNodePtr query_cur, char *orig_url);
int create_xml_title(xmlNodePtr root, xmlNodePtr query_cur, char *title);
int create_xml_date(xmlNodePtr root, xmlNodePtr query_cur, char *date);
int create_xml_rank(xmlNodePtr root, xmlNodePtr query_cur, char *rank);
int create_xml_size(xmlNodePtr root, xmlNodePtr query_cur, char *size);

#endif /* _XMLPARSER_H */

